package org.polarsys.capella.myquickfix;

import java.util.List;

import org.eclipse.core.resources.IMarker;
import org.eclipse.emf.ecore.EObject;
import org.polarsys.capella.common.ef.command.AbstractReadWriteCommand;
import org.polarsys.capella.common.helpers.TransactionHelper;
import org.polarsys.capella.common.mdsofa.common.constant.ICommonConstants;
import org.polarsys.capella.core.data.capellacore.CapellaElement;

public class AbstractCapellaMarkerResolution
		extends org.polarsys.capella.core.validation.ui.ide.quickfix.AbstractCapellaMarkerResolution {
	  /**
	   * @see org.eclipse.ui.IMarkerResolution#run(org.eclipse.core.resources.IMarker)
	   */
	  @Override
	  public void run(final IMarker marker_p) {
	    final List<EObject> modelElements = getModelElements(marker_p);
	    if (!modelElements.isEmpty()) {
	      // execute a read write command
	      TransactionHelper.getExecutionManager(modelElements).execute(new AbstractReadWriteCommand() {
	        /**
	         * @see java.lang.Runnable#run()
	         */
	        public void run() {
	          for (EObject obj : modelElements) {
	            if (obj instanceof CapellaElement) {
	              CapellaElement element = (CapellaElement) obj;
	              String summary = element.getSummary();
	              if ((null == summary) || ICommonConstants.EMPTY_STRING.equals(summary)) {
	                element.setSummary("generated summary"); //$NON-NLS-1$
	              }
	              String description = element.getDescription();
	              if ((null == description) || ICommonConstants.EMPTY_STRING.equals(description)) {
	                element.setDescription("generated description"); //$NON-NLS-1$
	              }
	            }
	          }
	        }
	      });
	    }
	  }

}
