package org.polarsys.capella.myvalidationrule;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.validation.IValidationContext;
import org.polarsys.capella.common.data.modellingcore.AbstractNamedElement;
import org.polarsys.capella.core.data.pa.PhysicalFunction;
import org.polarsys.capella.core.validation.rule.AbstractValidationRule;

public class CapellaTutorialValidationRule extends AbstractValidationRule {
  /**
   * {@inheritDoc}
   */
  @Override
  public IStatus validate(IValidationContext ctx) {
    EObject eObj = ctx.getTarget();
    if (eObj instanceof PhysicalFunction) {
      PhysicalFunction 	capellaElt = (PhysicalFunction) eObj;
      String desc = capellaElt.getDescription();
      String summary = capellaElt.getSummary();
      if (desc == null || desc.isEmpty() || summary == null || summary.isEmpty()) {
        if (capellaElt instanceof AbstractNamedElement) {
          AbstractNamedElement namedElt = (AbstractNamedElement) capellaElt;
          return ctx.createFailureStatus(new Object[] {capellaElt.eClass().getName(), namedElt.getName()});
        }
        return ctx.createFailureStatus(new Object[] {capellaElt.eClass().getName(), "<unnamed>"});
      }
    }
    return ctx.createSuccessStatus();
  }
}